package org.etsi.osl.tmf.gam673.api;

import com.fasterxml.jackson.databind.ObjectMapper;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.Parameter;
import io.swagger.v3.oas.annotations.responses.ApiResponse;
import io.swagger.v3.oas.annotations.responses.ApiResponses;
import jakarta.servlet.http.HttpServletRequest;
import jakarta.validation.Valid;
import org.etsi.osl.tmf.gam673.model.GeographicAddressValidation;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PatchMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;

import java.util.List;
import java.util.Optional;

@Generated
public interface GeographicAddressValidationManagementApi {
    default Optional<ObjectMapper> getObjectMapper() {
        return Optional.empty();
    }

    default Optional<HttpServletRequest> getRequest() {
        return Optional.empty();
    }

    default Optional<String> getAcceptHeader() {
        return getRequest().map(r -> r.getHeader("Accept"));
    }

    @Operation(summary = "Creates a 'GeographicAddressValidation'", operationId = "createGeographicAddressValidation", description = "", tags={ "GeographicAddressValidation", })
    @ApiResponses(value = {
            @ApiResponse(responseCode = "400", description = "Created" ),
            @ApiResponse(responseCode = "400", description = "Bad Request" ),
            @ApiResponse(responseCode = "401", description = "Unauthorized" ),
            @ApiResponse(responseCode = "403", description = "Forbidden" ),
            @ApiResponse(responseCode = "404", description = "Not Found" ),
            @ApiResponse(responseCode = "405", description = "Method Not allowed" ),
            @ApiResponse(responseCode = "409", description = "Conflict" ),
            @ApiResponse(responseCode = "500", description = "Internal Server Error" ) })
    @PostMapping(value = "/geographicAddressValidation",
            produces = { "application/json" },
            consumes = { "application/json" })
    ResponseEntity<GeographicAddressValidation> createGeographicAddressValidation(@Parameter(description = "The geographic address to be created", required = true) @Valid @RequestBody GeographicAddressValidation geographicAddressValidation);

    @Operation(summary = "Deletes a 'GeographicAddressValidation' by Id", operationId = "deleteGeographicAddressValidation", description = "", tags={ "GeographicAddressValidation", })
    @ApiResponses(value = {
            @ApiResponse(responseCode = "204", description = "Deleted" ),
            @ApiResponse(responseCode = "400", description = "Bad Request" ),
            @ApiResponse(responseCode = "401", description = "Unauthorized" ),
            @ApiResponse(responseCode = "403", description = "Forbidden" ),
            @ApiResponse(responseCode = "404", description = "Not Found" ),
            @ApiResponse(responseCode = "405", description = "Method Not allowed" ),
            @ApiResponse(responseCode = "409", description = "Conflict" ),
            @ApiResponse(responseCode = "500", description = "Internal Server Error" ) })
    @DeleteMapping(value = "/geographicAddressValidation/{id}",
            produces = { "application/json" })
    ResponseEntity<Void> deleteGeographicAddressValidation(@Parameter(description = "Identifier of the Geographic address", required = true) @PathVariable("id") String id);


    @Operation(summary = "List or find 'GeographicAddressValidation' objects", operationId = "listGeographicAddressValidation", description = "" , tags={ "GeographicAddressValidation", })
    @ApiResponses(value = {
            @ApiResponse(responseCode ="200", description = "Ok" ),
            @ApiResponse(responseCode = "400", description = "Bad Request" ),
            @ApiResponse(responseCode = "401", description = "Unauthorized" ),
            @ApiResponse(responseCode = "403", description = "Forbidden" ),
            @ApiResponse(responseCode = "404", description = "Not Found" ),
            @ApiResponse(responseCode = "405", description = "Method Not allowed" ),
            @ApiResponse(responseCode = "409", description = "Conflict" ),
            @ApiResponse(responseCode = "500", description = "Internal Server Error" ) })
    @GetMapping(value = "/geographicAddressValidation",
            produces = { "application/json" })
    ResponseEntity<List<GeographicAddressValidation>> listGeographicAddressValidation();


    @Operation(summary = "Updates partially a 'GeographicAddressValidation' by Id", operationId = "patchGeographicAddressValidation", description = "", tags={ "GeographicAddressValidation", })
    @ApiResponses(value = {
            @ApiResponse(responseCode ="200", description = "Updated" ),
            @ApiResponse(responseCode = "400", description = "Bad Request" ),
            @ApiResponse(responseCode = "401", description = "Unauthorized" ),
            @ApiResponse(responseCode = "403", description = "Forbidden" ),
            @ApiResponse(responseCode = "404", description = "Not Found" ),
            @ApiResponse(responseCode = "405", description = "Method Not allowed" ),
            @ApiResponse(responseCode = "409", description = "Conflict" ),
            @ApiResponse(responseCode = "500", description = "Internal Server Error" ) })
    @PatchMapping(value = "/geographicAddressValidation/{id}",
            produces = { "application/json" },
            consumes = { "application/json" })
    ResponseEntity<GeographicAddressValidation> patchGeographicAddressValidation(@Parameter(description = "Identifier of the Geographic address", required = true) @PathVariable("id") String id, @Parameter(description = "The Service Level Specification to be updated", required = true) @Valid @RequestBody GeographicAddressValidation geographicAddressValidation);


    @Operation(summary = "Retrieves a 'GeographicAddressValidation' by Id", operationId = "retrieveGeographicAddressValidation", description = "" , tags={ "GeographicAddressValidation", })
    @ApiResponses(value = {
            @ApiResponse(responseCode ="200", description = "Ok" ),
            @ApiResponse(responseCode = "400", description = "Bad Request" ),
            @ApiResponse(responseCode = "401", description = "Unauthorized" ),
            @ApiResponse(responseCode = "403", description = "Forbidden" ),
            @ApiResponse(responseCode = "404", description = "Not Found" ),
            @ApiResponse(responseCode = "405", description = "Method Not allowed" ),
            @ApiResponse(responseCode = "409", description = "Conflict" ),
            @ApiResponse(responseCode = "500", description = "Internal Server Error" ) })
    @GetMapping(value = "/geographicAddressValidation/{id}",
            produces = { "application/json" })
    ResponseEntity<GeographicAddressValidation> retrieveGeographicAddressValidation(@Parameter(description = "Identifier of the geographic address", required = true) @PathVariable("id") String id);

}
